<!DOCTYPE html>
<html>

<head>
    <meta charset="utf-8">
    <title>My first three.js app</title>
    <style>
        body {
            margin: 0;
        }

        canvas {
            display: block;
        }
    </style>
</head>

<body>

    <input type="file" id="file">
    <button onclick="_clicked1()">OK</button>

    <script src="hello.js"></script>

    <script>
        function Shell(eid, pid, n1, n2, n3, n4) {
            this.eid = eid || 0;
            this.pid = pid || 0;
            this.n1 = n1 || 0;
            this.n2 = n2 || 0;
            this.n3 = n3 || 0;
            this.n4 = n4 || 0;
            this.isDuplicate = false;

        }


    </script>

    <script>

        // <script type="module">

        // import {
        //     Shell,
        //     dot,
        //     Greeting,
        //     readJSObject
        // } from "./hello.wasm";


        var inputFile = document.getElementById('file');
        function fileChange(ev) {
            var target = ev.target;
            var files = target.files;
            console.log(files);
        }
        // inputFile.addEventListener('change', fileChange, false);
        inputFile.addEventListener('change', handleFileSelect, false);

        function handleFileSelect(evt) {

            console.log(Module);


            var files = evt.target.files; // FileList object
            var files = [].slice.call(evt.target.files); // FileList object
            // console.log([].slice.call(files));
            // nameでソート
            files.sort(function (a, b) {
                if (a.name > b.name) return 1;
                if (a.name < b.name) return -1;
                return 0;
            });
            console.log(files);

            var reader;
            f = files[0];
            console.log(f);
            reader = new FileReader();
            // reader.readAsDataURL(f);
            // reader.readAsBinaryString(f);
            reader.readAsArrayBuffer(f);
            // reader.readAsText(f);
            reader.onload = function (e) {
                console.log(e.target.result);
                perseBinary(e.target.result);

                // var input_array = new Int32Array([1, 20, 3, 4, 5]);
                // console.log(input_array);
                // var nByte = input_array.BYTES_PER_ELEMENT;
                // var length = input_array.length;
                // var ptr = Module._malloc(length * nByte);
                // Module.HEAP32.set(input_array, ptr / nByte);
                // // console.log(_IntSum(ptr, length));

                // // console.log(_perseBinary(ptr, length));
                // // _test();



                // console.log(_test());
                // console.log(intSum(a));


            }
        }
        // function callWASM(callback,, type) {


        // }



        function perseBinary(data) {
            var input_array = new Uint8Array(data);
            console.log((input_array instanceof Uint8Array));

            // // var d = new Uint8Array([1, 20, 3, 4, 5]);
            // // console.log(d);
            // // // var nByte = data.BYTES_PER_ELEMENT;
            // // var length = d.length;
            // // // var ptr = Module._malloc(length * nByte);
            // // const p = Module._malloc(length);
            // // Module.HEAP8.set(d, p)
            // // // Module.HEAP8.set(data, ptr / nByte);
            // // // console.log(_IntSum(ptr, length));

            // // var input_array = new Uint8Array([1, 20, 3, 4, 5]);
            // console.log(input_array);
            // var nByte = input_array.BYTES_PER_ELEMENT;
            // console.log(nByte);
            // var length = input_array.length;
            // var ptr = Module._malloc(length * nByte);
            // // Module.HEAP32.set(input_array, ptr / nByte);
            // Module.HEAPU8.set(input_array, ptr / nByte);
            // console.log(_perseBinary(ptr, length));
            // // _test();



            // var shells;
            // var shell = new Shell();
            // shell.eid = 100;
            // shell.pid = 10;
            // shell.n1 = 1;
            // shell.n2 = 2;
            // shell.n3 = 3;
            // shell.n4 = 4;
            // // console.log(typeof (shell.pid));
            // // shell.isDuplicate = false;
            // console.log(shell);
            // input_array = new Uint8Array([shell.eid, shell.pid, shell.n1, shell.n2, shell.n3, shell.n4]);
            // console.log(input_array);
            // nByte = input_array.BYTES_PER_ELEMENT;
            // length = input_array.length;
            // ptr = Module._malloc(length * nByte);
            // // Module.HEAP32.set(input_array, ptr / nByte);
            // Module.HEAPU8.set(input_array, ptr / nByte);
            // // _perseBinary(ptr, length);
            // // _readStruct(input_array);

            // input_array = new Uint8Array(JSON.stringify(shell));
            // var nByte = input_array.BYTES_PER_ELEMENT;
            // var length = input_array.length;
            // var ptr = Module._malloc(length * nByte);
            // // Module.HEAP32.set(input_array, ptr / nByte);
            // Module.HEAP8.set(input_array, ptr / nByte);
            // _readObject(ptr, length);
            // // // 1,2,4
            // // nByte = 2
            // // length = 1
            // // ptr = Module._malloc(length * nByte);
            // // Module.HEAP16.set(shell, ptr / nByte);
            // // _readStruct(ptr, length)
            // var x = new Module.MyStruct();
            // x.a = 10;
            // x.b = 20;
            // x.c = 30;
            // var y = Module.Foo(x, 21);
            // console.log(y, y.a, y.b, y.c);
            // console.log('lerp result: ' + Module.lerp(1, 2, 0.5));

            // var instance = new Module.MyClass(10, "hello");
            // instance.incrementX();
            // instance.x; // 11
            // instance.x = 20; // 20
            // Module.MyClass.getStringFromInstance(instance); // "hello"
            // instance.delete();

            var sh = new Module.Shell();
            sh.eid = 10;
            sh.pid = 100;
            sh.n1 = 1;
            sh.n2 = 2;
            sh.n4 = 4;
            sh.n3 = 3;
            sh.isDuplicate = false;

            var sh2 = new Module.Shell();
            sh2.eid = 20;
            sh2.pid = 200;
            sh2.isDuplicate = true;
            console.log(sh, sh2);
            console.log(Module.dot(sh, sh2));

            // const len = p.length;
            console.log(sh.isDuplicate);
            console.log(sh.eid);
            console.log(Module.Greeting(11));

            var shell1 = new Shell();
            shell1.eid = 9100;
            shell1.pid = 10;
            shell1.n1 = 1;
            shell1.n2 = 2;
            shell1.n3 = 3;
            shell1.n4 = 4;
            var shell2 = new Shell();
            shell2.eid = 9100;
            shell2.pid = 10;
            shell2.n1 = 1;
            shell2.n2 = 4;
            shell2.n3 = 3;
            shell2.n4 = 2;
            // console.log(shell1.isDuplicate, shell2.isDuplicate);
            // Module.findDuplicateShell(shell1, shell2);
            // console.log(shell1.isDuplicate, shell2.isDuplicate);



            var sh1 = new Module.Shell();
            sh1.eid = shell1.eid;
            sh1.pid = shell1.pid;
            sh1.n1 = shell1.n1;
            sh1.n2 = shell1.n2;
            sh1.n3 = shell1.n3;
            sh1.n4 = shell1.n4;
            sh1.isDuplicate = false;
            var sh2 = new Module.Shell();
            sh2.eid = shell2.eid;
            sh2.pid = shell2.pid;
            sh2.n1 = shell2.n1;
            sh2.n2 = shell2.n2;
            sh2.n3 = shell2.n3;
            sh2.n4 = shell2.n4;
            sh2.isDuplicate = false;


            var sh3 = new Module.Shell();
            console.log(sh3);
            sh3 = shell2;
            console.log(sh2.isDuplicate);



            var length = 500 // shells.length

            performance.mark('start01');
            var i = 0 | 0;
            var j = 0 | 0;
            while (i < length) {
                j = length - 1 | 0;
                while (j > i) {
                    findDuplicateShell(shell1, shell2);
                    j = (j - 1) | 0;
                }
                i = (i + 1) | 0;
            }
            performance.mark('end01');
            performance.measure('js', 'start01', 'end01');

            performance.mark('start01a');
            var i = 0 | 0;
            var j = 0 | 0;
            while (i < length) {
                j = length - 1 | 0;
                while (j > i) {
                    findDuplicateShell2(shell1, shell2);
                    j = (j - 1) | 0;
                }
                i = (i + 1) | 0;
            }
            performance.mark('end01a');
            performance.measure('js2', 'start01a', 'end01a');

            performance.mark('start02');
            i = 0 | 0;
            j = 0 | 0;
            while (i < length) {
                j = length - 1 | 0;
                while (j > i) {
                    // Module.findDuplicateShell(shell1, shell2);
                    Module.findDuplicateShell2(sh1, sh2);
                    j = (j - 1) | 0;
                }
                i = (i + 1) | 0;
            }
            performance.mark('end02');
            performance.measure('wsam1', 'start02', 'end02');

            performance.mark('start03');
            Module.setDuplicateShellFlag(shell1, shell2, length);
            performance.mark('end03');
            performance.measure('wsam2', 'start03', 'end03');

            performance.mark('start04');
            var ret;
            i = 0 | 0;
            j = 0 | 0;
            while (i < length) {
                j = length - 1 | 0;
                while (j > i) {
                    ret = i * 10;
                    j = (j - 1) | 0;
                }
                i = (i + 1) | 0;
            }
            console.log(ret);
            performance.mark('end04');
            performance.measure('loop_js', 'start04', 'end04');

            performance.mark('start05');
            // console.log(Module.LoopTest(shell1, shell2, length));
            performance.mark('end05');
            performance.measure('loop_wsam', 'start05', 'end05');

            findDuplicateShell2(shell1, shell2);

            console.log('jS:', performance.getEntriesByName('js')[0].duration, '[ms]');
            console.log('jS2:', performance.getEntriesByName('js2')[0].duration, '[ms]');
            console.log('wsam1:', performance.getEntriesByName('wsam1')[0].duration, '[ms]');
            console.log('wsam2:', performance.getEntriesByName('wsam2')[0].duration, '[ms]');
            console.log('loop_js:', performance.getEntriesByName('loop_js')[0].duration, '[ms]');
            console.log('loop_wsam:', performance.getEntriesByName('loop_wsam')[0].duration, '[ms]');

        }

        function findDuplicateShell(shell1, shell2) {
            // console.log('findDuplicateShell');
            if (shell1.n3 === shell1.n4) {
                if (shell2.n3 === shell2.n4) {
                    if ((shell1.n1 === shell2.n1) && (shell1.n2 === shell2.n3) && (shell1.n3 === shell2.n2)) {
                        shell1.isDuplicate = true;
                        shell2.isDuplicate = true;
                    }
                    if ((shell1.n1 === shell2.n3) && (shell1.n2 === shell2.n2) && (shell1.n3 === shell2.n1)) {
                        shell1.isDuplicate = true;
                        shell2.isDuplicate = true;
                    }
                    if ((shell1.n1 === shell2.n2) && (shell1.n2 === shell2.n1) && (shell1.n3 === shell2.n3)) {
                        shell1.isDuplicate = true;
                        shell2.isDuplicate = true;
                    }
                }
            }
            else {
                if ((shell1.n1 === shell2.n4) && (shell1.n2 === shell2.n3) && (shell1.n3 === shell2.n2) && (shell1.n4 === shell2.n1)) {
                    shell1.isDuplicate = true;
                    shell2.isDuplicate = true;
                }
                if ((shell1.n1 === shell2.n3) && (shell1.n2 === shell2.n2) && (shell1.n3 === shell2.n1) && (shell1.n4 === shell2.n4)) {
                    shell1.isDuplicate = true;
                    shell2.isDuplicate = true;
                }
                if ((shell1.n1 === shell2.n2) && (shell1.n2 === shell2.n1) && (shell1.n3 === shell2.n4) && (shell1.n4 === shell2.n3)) {
                    shell1.isDuplicate = true;
                    shell2.isDuplicate = true;
                }
                if ((shell1.n1 === shell2.n1) && (shell1.n2 === shell2.n4) && (shell1.n3 === shell2.n3) && (shell1.n4 === shell2.n2)) {
                    shell1.isDuplicate = true;
                    shell2.isDuplicate = true;
                }
            }
            return;
        }


        // オリジナルの8倍遅い(544ms/39.9ms)
        function findDuplicateShell2(shell1, shell2) {
            var array, array2;
            if (shell1.n3 === shell1.n4) {
                if (shell2.n3 === shell2.n4) {
                    array = [shell1.n1, shell1.n2, shell1.n3, shell1.n4, shell2.n1, shell2.n2, shell2.n3, shell2.n4]
                    array2 = array.filter(function (x, i, self) {
                        return self.indexOf(x) !== self.lastIndexOf(x);
                    });
                    if (array2.length == 6) {
                        shell1.isDuplicate = true;
                        shell2.isDuplicate = true;
                    }
                }
            }
            else {
                array = [shell1.n1, shell1.n2, shell1.n3, shell1.n4, shell2.n1, shell2.n2, shell2.n3, shell2.n4]
                array2 = array.filter(function (x, i, self) {
                    return self.indexOf(x) !== self.lastIndexOf(x);
                });
                if (array2.length == 8) {
                    shell1.isDuplicate = true;
                    shell2.isDuplicate = true;
                }

            }
            return;
        }





    </script>

    <!-- <script type="text/javascript" src="hello.js"></script> -->




</body>

</html>
